#ifndef ZEGA_H
#define ZEGA_H
#include<qwidget.h>
#include<qpe/config.h>
#include<qmenubar.h>
#include<qpopupmenu.h>
#include<qapplication.h>
#include<qmessagebox.h>
#include"qtkfiledialog.h"
#include<qimage.h>
#include<qpainter.h>
#include<qtimer.h>
#include"maplist.h"
#include"gpsloghandler.h"

/*
 #define _DEBUG_PRINT
 */

class Zega : public QWidget {
	Q_OBJECT

public:
	Zega(QWidget* parent, const char* name);

	// static member
	static Config config;

protected:
	void paintEvent(QPaintEvent*);

private:
	void mousePressEvent(QMouseEvent *event);
	void resizeEvent(QResizeEvent *event);
	void keyPressEvent(QKeyEvent *event);
	void paintMaps(Radian radNS, Radian radEW);
	bool getMapInfo(QString mapFileName, Radian *radMapEW, Radian *radMapEW, Radian *radMapWidth, Radian *radMapHeight);
	bool copyMap(int x, int y, Radian radEW, Radian radNS);

	QMenuBar *_menu;
	QPopupMenu *_filemenu;
	QPopupMenu *_gpsmenu;
	QPopupMenu *_scalemenu;
	QPopupMenu *_helpmenu;
	QImage *_buffer;
	QPixmap *_mapBuffer;
	MapList *_mapList;
	GpsLogHandler *_gpsLogHandler;
	QStringList mapDirs;

	// ̹ѤΥޡ
	QTimer *_updateTimer;

	Radian _centerNS;
	Radian _centerEW;
	long _pixelNS;
	long _pixelEW;
	int _bsl, _bsr, _bsu, _bsd;
	bool _autoCentered;

	// ϩ
	vector<Coordinate> _route;

private slots:
	void about();
	void slotLoad();
	void slotChScale(int);
	void slotRePaint();
	void startGps();
	void stopGps();
};

#endif //ZEGA_H
